<?php
declare(strict_types=1);

namespace Intergo\LaravelAuthMiddleware\Http\Middleware;
use Intergo\LaravelAuthMiddleware\Traits\ResponseTrait;
use Illuminate\Http\Request;
use Closure;

class Authenticate extends AbstractAuthMiddleware
{
    use ResponseTrait;
    /**
     * Handle an incoming request.
     *
     * @param Request $request
     * @param Closure $next
     * @param string $params
     * @return mixed
     */
    public function handle(Request $request, Closure $next, string $params = ''): mixed
    {
        $result = parent::handle($request, $next);
        if (!$result->isSuccessful()) {
            if ($request->isJson()) {
                return $this->failed('Invalid API Key or Token', [], $result->getStatusCode());
            } else {
                return redirect(route('login'));
            }
        }
        return $next($this->request);
    }
}

